package mastermind.logic;

import java.util.logging.Level;
import java.util.logging.Logger;
import mastermind.model.Guess;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author Felix Rohrer <felix.rohrer@stud.hslu.ch>
 */
public class GuessHandlerTest
{

    public GuessHandlerTest()
    {
    }

    /**
     * Test of validateGuess method, of class GuessHandler.
     */
    @Test
    public void testValidateGuess_intArr()
    {
        System.out.println("validateGuess: true");
        // define settings
        int numberOfColors = 4;
        boolean allowDuplicateColor = false;
        int numberOfPegs = 4;
        int numberOfRows = 4;
        try {
            SettingsHandler.getInstance().getSettings().setSettings(numberOfColors, allowDuplicateColor, numberOfPegs, numberOfRows);
        } catch (Exception ex) {
            Logger.getLogger(GuessHandlerTest.class.getName()).log(Level.SEVERE, null, ex);
        }

        int[] pegs = new int[] {1,2,3,4};
        boolean expResult = true;
        boolean result = GuessHandler.validateGuess(pegs);
        assertEquals(expResult, result);
        
        System.out.println("validateGuess: false (duplicate color)");
        pegs = new int[] {1,1,1,1};
        expResult = false;
        result = GuessHandler.validateGuess(pegs);
        assertEquals(expResult, result);

        System.out.println("validateGuess: false (number of color)");
        pegs = new int[] {6,7,8,9};
        expResult = false;
        result = GuessHandler.validateGuess(pegs);
        assertEquals(expResult, result);

        System.out.println("validateGuess: false (number of pegs)");
        pegs = new int[] {1,2,3};
        expResult = false;
        result = GuessHandler.validateGuess(pegs);
        assertEquals(expResult, result);

        
    }

    /**
     * Test of validateGuess method, of class GuessHandler.
     */
    @Test
    public void testValidateGuess_Guess()
    {
        System.out.println("validateGuess(Guess): true");
        // define settings
        int numberOfColors = 4;
        boolean allowDuplicateColor = false;
        int numberOfPegs = 4;
        int numberOfRows = 4;
        try {
            SettingsHandler.getInstance().getSettings().setSettings(numberOfColors, allowDuplicateColor, numberOfPegs, numberOfRows);
        } catch (Exception ex) {
            Logger.getLogger(GuessHandlerTest.class.getName()).log(Level.SEVERE, null, ex);
        }

        int[] pegs = new int[] {1,2,3,4};
        Guess guess = new Guess(pegs);
        boolean expResult = true;
        boolean result = GuessHandler.validateGuess(guess);
        assertEquals(expResult, result);

        System.out.println("validateGuess(Guess): false");
        pegs = new int[] {1,2};
        guess = new Guess(pegs);
        expResult = false;
        result = GuessHandler.validateGuess(guess);
        assertEquals(expResult, result);
    }
}
