
package mastermind.model;

import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author Felix Rohrer <felix.rohrer@stud.hslu.ch>
 */
public class GuessTest {

    public GuessTest() {
    }

    /**
     * Test of setPegs method, of class Guess.
     */
    @Test
    public void testSetGetPegs()
    {
        System.out.println("setPegs / getPegs");
        int[] pegs = new int[] {1,2,3,4};
        Guess instance = new Guess();
        instance.setPegs(pegs);
        assertArrayEquals(pegs, instance.getPegs());
    }

    /**
     * Test of setPeg method, of class Guess.
     */
    @Test
    public void testSetPeg()
    {
        System.out.println("setPeg");
        int pos = 2;
        int color = 4;
        int[] expResult = new int[] {1,1,4,1};
        Guess instance = new Guess(new int[] {1,1,1,1});
        instance.setPeg(pos, color);
        assertArrayEquals(expResult, instance.getPegs());
    }

    /**
     * Test of toString method, of class Guess.
     */
    @Test
    public void testToString()
    {
        System.out.println("toString");
        Guess instance = new Guess(new int[] {1,2,3,4});
        String expResult = "[1, 2, 3, 4]";
        String result = instance.toString();
        assertEquals(expResult, result);
    }

    /**
     * Test of equals method, of class Guess.
     */
    @Test
    public void testEquals()
    {
        System.out.println("equals");
        Object otherGuess = new Guess(new int[] {1,2,3,4});
        Guess instance = new Guess(new int[] {1,2,3,4});
        boolean expResult = true;
        boolean result = instance.equals(otherGuess);
        assertEquals(expResult, result);
    }


}