
package mastermind.model;

import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author Felix Rohrer <felix.rohrer@stud.hslu.ch>
 */
public class ResultTest {

    public ResultTest() {
    }


    /**
     * Test of getAnzPegColorPosRight method, of class Result.
     */
    @Test
    public void testGetAnzPegColorPosRight()
    {
        System.out.println("getAnzPegColorPosRight");
        Result instance = new Result(7, 0);
        int expResult = 7;
        int result = instance.getAnzPegColorPosRight();
        assertEquals(expResult, result);
    }

    /**
     * Test of setAnzPegColorPosRight method, of class Result.
     */
    @Test
    public void testSetAnzPegColorPosRight()
    {
        System.out.println("setAnzPegColorPosRight");
        // set 7
        int anzPegColorPosRight = 7;
        Result instance = new Result(0,0);
        instance.setAnzPegColorPosRight(anzPegColorPosRight);
        assertEquals(anzPegColorPosRight, instance.getAnzPegColorPosRight());
    }

        /**
     * Test of setAnzPegColorPosRight method, of class Result.
     */
    @Test
    public void testSetAnzPegColorPosRight_SetNegative()
    {
        // try to set -5
        System.out.println("setAnzPegColorPosRight: try to set < 0");
        Result instance = new Result(7,7);
        instance.setAnzPegColorPosRight(-5);
        assertEquals(0, instance.getAnzPegColorPosRight());
    }

    /**
     * Test of getAnzPegColorRight method, of class Result.
     */
    @Test
    public void testGetAnzPegColorRight()
    {
        System.out.println("getAnzPegColorRight");
        Result instance = new Result(0, 5);
        int expResult = 5;
        int result = instance.getAnzPegColorRight();
        assertEquals(expResult, result);
    }

    /**
     * Test of setAnzPegColorRight method, of class Result.
     */
    @Test
    public void testSetAnzPegColorRight()
    {
        System.out.println("setAnzPegColorRight");
        // set 5
        int anzPegColorRight = 5;
        Result instance = new Result(0, 0);
        instance.setAnzPegColorRight(anzPegColorRight);
        assertEquals(anzPegColorRight, instance.getAnzPegColorRight());

        // try to set -3
        System.out.println("setAnzPegColorRight: try to set < 0");
        instance = new Result(5, 5);
        instance.setAnzPegColorRight(-3);
        assertEquals(0, instance.getAnzPegColorRight());
    }

        /**
     * Test of setAnzPegColorRight method, of class Result.
     */
    @Test
    public void testSetAnzPegColorRight_SetNegative()
    {
        // try to set -3
        System.out.println("setAnzPegColorRight: try to set < 0");
        Result instance = new Result(5, 5);
        instance.setAnzPegColorRight(-3);
        assertEquals(0, instance.getAnzPegColorRight());
    }

    /**
     * Test of incAnzPegColorPosRight method, of class Result.
     */
    @Test
    public void testIncAnzPegColorPosRight()
    {
        System.out.println("incAnzPegColorPosRight");
        Result instance = new Result(6, 0);
        instance.incAnzPegColorPosRight();
        int expResult = 7;
        assertEquals(expResult, instance.getAnzPegColorPosRight());
    }

    /**
     * Test of incAnzPegColorRight method, of class Result.
     */
    @Test
    public void testIncAnzPegColorRight()
    {
        System.out.println("incAnzPegColorRight");
        Result instance = new Result(0, 6);
        instance.incAnzPegColorRight();
        int expResult = 7;
        assertEquals(expResult, instance.getAnzPegColorRight());
    }

    /**
     * Test of getResult method, of class Result.
     */
    @Test
    public void testGetResult()
    {
        System.out.println("getResult");
        Result instance = new Result(5, 7);
        int[] expResult = new int[] {5, 7};
        int[] result = instance.getResult();
        assertArrayEquals(expResult, result);
    }

    /**
     * Test of getResultAsString method, of class Result.
     */
    @Test
    public void testGetResultAsString()
    {
        System.out.println("getResultAsString");
        Result instance = new Result(2, 3);
        String expResult = "Schwarz: 2, Weiss: 3";
        String result = instance.getResultAsString();
        assertEquals(expResult, result);
    }

    /**
     * Test of toString method, of class Result.
     */
    @Test
    public void testToString()
    {
        System.out.println("toString");
        Result instance = new Result(3, 4);
        String expResult = "Schwarz: 3, Weiss: 4";
        String result = instance.toString();
        assertEquals(expResult, result);
    }

}